/**
 * Klasse Fahrscheinautomat.
 * 
 * @author R. Punkenburg 
 * @version 2.2.2006
 */
public class Fahrscheinautomat
{
    private int fahrscheinWert;
    private boolean fahrscheinGewaehlt;
    private int summe;
    private Muenzpruefer muenzpruefer;
    private Drucker drucker;
    private Muenzschacht muenzen5;
    private Muenzschacht muenzen10;
    private Muenzschacht muenzen20;
    private Muenzschacht muenzen50;
    private Muenzschacht muenzen100;
    private Muenzschacht muenzen200;
    private Geldkassette geldkassette;
    private boolean passendZahlen;

    /**
     * Konstruktor fr Objekte der Klasse Fahrscheinautomat;
     * Es ist kein Fahrschein gewhlt;
     * Es ist keine Mnze eingeworfen worden.
     */
    public Fahrscheinautomat()
    {
        fahrscheinWert = 0;
        fahrscheinGewaehlt = false;
        summe = 0;
        muenzpruefer = new Muenzpruefer();
        drucker = new Drucker();
        muenzen5 = new Muenzschacht("5");
        muenzen10 = new Muenzschacht("10");
        muenzen20 = new Muenzschacht("20");
        muenzen50 = new Muenzschacht("50");
        muenzen100 = new Muenzschacht("100");
        muenzen200 = new Muenzschacht("200");
        geldkassette = new Geldkassette();
        passendZahlen = passendZahlen();
        
    }
    
    /**
     * Methode zum Verarbeiten der eingeworfenen Mnzen;
     * nur wenn ein Fahrschein gewhlt worden ist, werden Mnzeinwrfe akzeptiert;
     * wenn ausreichend Mnzen eingeworfen worden sind, wird der Vorgang abgearbeitet.
     * @param  wert  Wert der eingeworfenen Mnze
     */
    public void muenzEinwurf(int wert)
    {
        // prfen, ob Fahrschein gewhlt wurde
        if (!fahrscheinGewaehlt)
        {
            System.out.println("FSA: Bitte zunchst einen Fahrschein whlen!");
            return; // keine weitere Verarbeitung
        }

        // Mnze prfen, falls ungltig Methode abbrechen
        if (muenzpruefer.pruefe(wert) == 0)
        {
            System.out.println("FSA: Sie haben bisher insgesamt "+summe+" Cent eingeworfen.");
            return; // Methode abbrechen
        }
        
        // nchste Mnze annehmen
        verbucheMuenze(wert);
        summe += wert;
        System.out.println("FSA: Sie haben eine Mnze von "+wert+" Cent eingeworfen.");
        System.out.println("FSA: Sie haben bisher insgesamt "+summe+" Cent eingeworfen.");
        
        // summe nicht ausreichend
        if (summe < fahrscheinWert)
        {
            System.out.println("FSA: Noch zu zahlen: "+(fahrscheinWert-summe));
            System.out.println("FSA: Bitte weitere Mnzen einwerfen.");
        }
        // summe ausreichend
        else if ((summe >= fahrscheinWert && !passendZahlen)||(summe == fahrscheinWert && passendZahlen)) 
        {
            drucker.druckeFahrschein(fahrscheinWert);
            //System.out.println("FSA: Sie erhalten "+(summe-fahrscheinWert)+" Cent zurck.");
            wechselgeldAuszahlen(summe-fahrscheinWert);
            // Attribute zurcksetzen
            fahrscheinGewaehlt = false;
            fahrscheinWert = 0;
            summe = 0;
        }
        else // also summe>fahrscheinWert && passendZahlen -> nun Mnze zurckweisen
        {
            summe -= wert; // summe zurcksetzen
            System.out.println("FSA: Sie mssen passend zahlen!");
            wechselgeldAuszahlen(wert);
            System.out.println("FSA: Sie haben bisher insgesamt "+summe+" Cent eingeworfen.");
            System.out.println("FSA: Noch zu zahlen: "+(fahrscheinWert-summe));
            System.out.println("FSA: Bitte weitere Mnzen einwerfen.");
        }
    } // muenzEinwurf
    
    private boolean passendZahlen()
    {
        if (   muenzen5.getAnzahl()<2
            || muenzen10.getAnzahl()<2
            || muenzen20.getAnzahl()<3
            || muenzen50.getAnzahl()<2
            || muenzen100.getAnzahl()<2) return true;
        else return false;
    }
    
    private void wechselgeldAuszahlen(int betrag)
    {
        while (betrag > 0)
        {
            if (betrag/200 >0)
            {muenzen200.auswerfen();betrag -=200;}
            
            else if (betrag/100 >0)
            {muenzen100.auswerfen();betrag -=100;}
            
            else if (betrag/50 >0)
            {muenzen50.auswerfen();betrag -=50;}
            
            else if (betrag/20 >0)
            {muenzen20.auswerfen();betrag -=20;}
            
            else if (betrag/10 >0)
            {muenzen10.auswerfen();betrag -=10;}
            
            else if (betrag/5 >0)
            {muenzen5.auswerfen();betrag -=5;}
            
            else System.out.println("wechselgeldAuszahlen: Fehler!!!!");
            
        }
        
    }
    
    
    /**
     * Methode zum Verbuchen der eingeworfenen Mnzen in dem entsprechenden
     * Mnzschacht bzw. in der Geldkassette;
     * wenn der Mnzschacht voll ist, wird die Mnze in der Geldkassette abgelegt, sonst im Mnzschacht.
     * @param  wert  Wert der eingeworfenen Mnze
     */
    private void verbucheMuenze(int wert)
    {
        if (wert==5) 
        {
            if (muenzen5.istVoll()) geldkassette.aufstocken(wert);
            else muenzen5.aufstocken();
        }
        if (wert==10) 
        {
            if (muenzen10.istVoll()) geldkassette.aufstocken(wert);
            else muenzen10.aufstocken();
        }
        if (wert==20) 
        {
            if (muenzen20.istVoll()) geldkassette.aufstocken(wert);
            else muenzen20.aufstocken();
        }
        if (wert==50) 
        {
            if (muenzen50.istVoll()) geldkassette.aufstocken(wert);
            else muenzen50.aufstocken();
        }
        if (wert==100) 
        {
            if (muenzen100.istVoll()) geldkassette.aufstocken(wert);
            else muenzen100.aufstocken();
        }
        if (wert==200) 
        {
            if (muenzen200.istVoll()) geldkassette.aufstocken(wert);
            else muenzen200.aufstocken();
        }
    } // verbucheMuenze
    
    
    
    /**
     * Methode zum Auswhlen des Fahrscheins;
     * Typ = 1 : Fahrschein fr 145 Cent;
     * Typ = 2 : Fahrschein fr 185 Cent;
     * Typ = 3 : Fahrschein fr 220 Cent;
     * alle anderen Eingaben sind ungltig
     * @param  typ  Typ des Fahrscheins
     */
    public void waehleFahrschein(int typ)
    {
        if (drucker.leer())
        {
            System.out.println("FSA: Der Automat ist auer Betrieb!");
            return; // Methode abbrechen
        }
        
        if (fahrscheinGewaehlt)
        {
            System.out.println("FSA: Sie haben bereits einen Fahrschein gewhlt!");
            System.out.println("FSA: Weitere Mnzen einwerfen oder ABBRUCH whlen!");
            return;
        }
        
        if (typ == 1)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 145;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 1,45 Euro. Bitte Mnzen einwerfen!");
        }
        else if (typ == 2)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 185;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 1,85 Euro. Bitte Mnzen einwerfen!");
        }
        else if (typ == 3)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 220;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 2,20 Euro. Bitte Mnzen einwerfen!");
        }
        else
        {
            fahrscheinGewaehlt = false;
            fahrscheinWert = 0;
            System.out.println("FSA: Ungltige Fahrscheinwahl!");
        }
        passendZahlen = passendZahlen(); // Zustand abfragen
        if (passendZahlen)
        {
            System.out.println("FSA: Bitte passend zahlen!");
        }
    } // waehleFahrschein
    
    /**
     * Methode zum Abbrechen eines laufenden Vorgangs;
     * evtl. bereits eingeworfene Geld wird zurckgegeben;
     * kein Fahrschein ist gewhlt
     */
    public void abbrechen()
    {
        if (!fahrscheinGewaehlt) return; // nichts tun, weil nichts rckgngig zu machen ist
        System.out.println("FSA: Vorgang abgebrochen!");
        if (summe >0) 
        {
            System.out.println("FSA: Sie erhalten "+summe+" Cent zurck.");
            wechselgeldAuszahlen(summe);
        }
        fahrscheinGewaehlt = false;
        fahrscheinWert = 0;
        summe = 0;
    } // abbrechen
    
    
} // Fahrscheinautomat
